Option Strict Off
Option Explicit On
Friend Class Form1
	Inherits System.Windows.Forms.Form
	
    Dim DeviceIndex As UInt32
	
	Const Channels As Short = 2
	
	Private Sub ADPollTime_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ADPollTime.Tick
		Dim Status As Integer
		Dim Volts(Channels - 1) As Double
		Dim Channel As Integer
		
		Status = ADC_GetScanV(DeviceIndex, Volts(0))
		If Status <> 0 Then
			StopButton.PerformClick()
			
			MsgBox("Error " & Status & " from ADC_GetScanV.",  , "ADC_GetScanV Error")
			
			Exit Sub
		End If
		
		For Channel = 0 To Channels - 1
			VB6.SetItemString(VoltList, Channel, "Ch " & Channel & ": " & Volts(Channel) & " V")
		Next 
	End Sub
	
	Private Sub DACSetButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles DACSetButton.Click
		Dim I As Integer
		
		I = DACCombo.SelectedIndex
		If (I < 0) Or (I > 3) Then
			Beep()
			Exit Sub
		End If
		
		'Set the DAC range, to unsleep the DAC/ADC reference.
		DACSetBoardRange(DeviceIndex, I)
		
		DACLabel.Visible = False
		DACCombo.Visible = False
		DACSetButton.Visible = False
		GoButton.Enabled = True
	End Sub
	
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		Dim Dlg As DetectForm
		Dim Status As Integer
		
		'dummy variables for function call since we can't do null in VBasic
		Dim PID As Integer
		Dim NameSize As Integer
		'UPGRADE_NOTE: Name was upgraded to Name_Renamed. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
		Dim Name_Renamed As String
		Dim DIOBytes As Integer
		Dim Counters As Integer
		Dim outdata As Integer
		
		NameSize = 256
		Name_Renamed = New String(" ", NameSize)
		
		'If you only have the one board, QueryDeviceInfo with diOnly will succeed
		'with the right PID. If you have more than one board, or haven't plugged it
		'in, it will fail, and this code will pop up the detector form so the user
		'can pick a board or cancel.
		DeviceIndex = diOnly
		Status = QueryDeviceInfo(DeviceIndex, PID, NameSize, Name_Renamed, DIOBytes, Counters)
		If (Status <> 0) Or Not ((PID >= &H8070) And (PID <= &H807F)) Then
			Dlg = New DetectForm
			Dlg.ShowDialog()
			DeviceIndex = Dlg.DeviceIndex
			Dlg.Close()
			
			If DeviceIndex = -1 Then
				Me.Close()
				Exit Sub
			End If
		End If
		
		DACCombo.SelectedIndex = 2
	End Sub
	
	Private Sub GoButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles GoButton.Click
		GoButton.Enabled = False
		StopButton.Enabled = True
		
		ADPollTime.Enabled = True
	End Sub
	
	Private Sub StopButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles StopButton.Click
		ADPollTime.Enabled = False
		
		GoButton.Enabled = True
		StopButton.Enabled = False
	End Sub
End Class