Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class DetectForm
	Inherits System.Windows.Forms.Form
	
	Public DetectOK As Boolean
	Public DeviceIndex As Integer
	
	Dim DeviceOK(7) As Boolean
	
	Private Sub DetectButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles DetectButton.Click
		Dim DeviceMask As Integer
		Dim PID As Integer
		Dim NameSize As Integer
		'UPGRADE_NOTE: Name was upgraded to Name_Renamed. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="A9E4979A-37FA-4718-9994-97DD76ED70A7"'
		Dim Name_Renamed As String
		Dim I As Short
		Dim Found As Boolean
		
		DeviceList.Items.Clear()
		Found = False
		DeviceMask = GetDevices()
		For I = 0 To 7
			DeviceOK(I) = False
			If (DeviceMask And (2 ^ I)) <> 0 Then
				NameSize = 256
				Name_Renamed = Space(NameSize)
				Call QueryDeviceInfo(I, PID, NameSize, Name_Renamed, 0, 0)
				Name_Renamed = VB.Left(Name_Renamed, NameSize)
				If ((PID >= &H8070) And (PID <= &H807F)) Then 'USB-AO16 family
					Found = True
					DeviceOK(I) = True
				Else
					Name_Renamed = Name_Renamed & " <not for this sample>"
				End If 'PID
			Else
				Name_Renamed = "<no device at this index>"
			End If 'DeviceMask
			Call DeviceList.Items.Add(Str(I) & ": " & Name_Renamed)
		Next I
		
		If Found Then
			StatusMemo.Text = "Select the device you want to work with and click Go."
		Else
			StatusMemo.Text = "No compatible devices found; your device may not be installed, or may not be installed properly. Click Redetect to check again."
		End If
	End Sub
	
	Private Sub DetectForm_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		Call DetectButton_Click(DetectButton, New System.EventArgs())
		DeviceList.SetSelected(0, True)
	End Sub
	
	Private Sub GoButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles GoButton.Click
		Dim I As Short
		
		I = DeviceList.SelectedIndex
		If (I = -1) Or (Not DeviceOK(I)) Then 'No device index selected or Invalid device index selected
			Beep()
			'End Sub
		End If
		
		DetectOK = True
		DeviceIndex = I
		Me.Hide()
	End Sub
End Class