Option Strict Off
Option Explicit On
Friend Class MainForm
	Inherits System.Windows.Forms.Form
	
    Dim DeviceIndex As UInteger

	
	'Compensates for the lack of unsigned types and range-check problems.
	Private Function As16(ByRef I32 As Integer) As Short
		Dim Result As Short
		Result = I32 And &H7FFFs
		If I32 And &H8000 Then Result = Result Or &H8000s
		As16 = Result
	End Function
	
	Private Sub ConfirmButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles ConfirmButton.Click
		If DACSetBoardRange(DeviceIndex, RangeCombo.SelectedIndex) = 0 Then
			ConfirmButton.Text = "Confirmed"
			DACFrame0.Visible = True
			DACFrame1.Visible = True
			ConfirmButton.Enabled = False
		End If
	End Sub
	
	Private Sub CountSlider_Change(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CountSlider.Change
		Dim Index As Short = CountSlider.GetIndex(eventSender)
		Dim Counts As Integer
		Dim Buf As String
		
		Counts = CountSlider(Index).Value
		Buf = Hex(Counts)
		Buf = New String("0", 4 - Len(Buf)) & Buf
		CountLabel(Index).Text = Buf
		If UpdateCheck.CheckState Then
			DACDirect(DeviceIndex, Index, As16(Counts))
		Else
			CountLabel(Index).BackColor = System.Drawing.ColorTranslator.FromOle(&H8000)
			CountLabel(Index).ForeColor = System.Drawing.ColorTranslator.FromOle(&HFFFFFF)
		End If
	End Sub
	
	Private Sub CountSlider_Scroll(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CountSlider.Scroll
		Dim Index As Short = CountSlider.GetIndex(eventSender)
		CountSlider_Change(CountSlider.Item(Index), New System.EventArgs())
	End Sub
	
	Private Sub MainForm_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		Dim Status, PID, I As Integer
		
		DeviceIndex = diOnly
		
		Status = QueryDeviceInfo(DeviceIndex, PID, 0, "", 0, 0)
		If (Status <> 0) Or (PID < &H8070) Or (PID > &H807F) Then
			VB6.ShowForm(DetectForm, VB6.FormShowConstants.Modal, Me)
			If DetectForm.DetectOK Then
				DeviceIndex = DetectForm.DeviceIndex
				DetectForm.Close()
				QueryDeviceInfo(DeviceIndex, PID, 0, "", 0, 0)
			Else
				DetectForm.Close()
				Me.Close()
				Exit Sub
			End If
		End If
		
		For I = 0 To 15
			DACDirect(DeviceIndex, I, 0)
		Next 
		
		DACSetBoardRange(DeviceIndex, 0) 'Turn on the DACs.
	End Sub
	
	Private Sub UpdateButton_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles UpdateButton.Click
        Dim Changes(15) As DACChange
		Dim I As Integer
		
		For I = 0 To 15
			Changes(I).Channel = I
            Changes(I).Counts = As16(CountSlider(I).Value)
		Next 

        DACMultiDirect(DeviceIndex, Changes(0), 2)
		
		For I = 0 To 15
			CountLabel(I).BackColor = BackColor
			CountLabel(I).ForeColor = ForeColor
		Next 
	End Sub
	
	'UPGRADE_WARNING: Event UpdateCheck.CheckStateChanged may fire when form is initialized. Click for more: 'ms-help://MS.VSCC.v80/dv_commoner/local/redirect.htm?keyword="88B12AE1-6DE0-48A0-86F1-60C0686C026A"'
	Private Sub UpdateCheck_CheckStateChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles UpdateCheck.CheckStateChanged
		If UpdateCheck.CheckState Then UpdateButton_Click(UpdateButton, New System.EventArgs())
		UpdateButton.Enabled = Not UpdateCheck.CheckState
	End Sub
End Class